//+------------------------------------------------------------------+
//|                                                   PriceVSwma.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "perky_z@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 Red


extern int    smoothing       = 13;
extern int    arrowSize       = 2;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double TrendBuffer[];
double LoBuffer[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,CrossUp);  SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,233);
   SetIndexBuffer(1,CrossDn);  SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,234);
   SetIndexBuffer(2,TrendBuffer);
   SetIndexBuffer(3,LoBuffer);
   SetIndexBuffer(4,trend);
   IndicatorShortName("ZLS("+smoothing+")");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Average Directional Movement Index                               |
//+------------------------------------------------------------------+
int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double stok5 = (iStochastic(NULL,0,52,12,3,MODE_LWMA,NULL,MODE_MAIN,i))*0.00;
      double stok4 = (iStochastic(NULL,0,34, 8,3,MODE_LWMA,NULL,MODE_MAIN,i))*0.0;
      double stok3 = (iStochastic(NULL,0,21, 5,3,MODE_LWMA,NULL,MODE_MAIN,i))*0.10;
      double stok2 = (iStochastic(NULL,0,12, 4,3,MODE_LWMA,NULL,MODE_MAIN,i))*0.65;
      double stok1 = (iStochastic(NULL,0, 8, 3,3,MODE_LWMA,NULL,MODE_MAIN,i))*0.25;
      TrendBuffer[i] = stok1+stok2+stok3+stok4+stok5;
      LoBuffer[i]    = TrendBuffer[i] /smoothing + LoBuffer[i+1]*(smoothing-1)/smoothing;    
	   trend[i] = trend[i+1];
         if (TrendBuffer[i]>LoBuffer[i]) trend[i] = 1;
         if (TrendBuffer[i]<LoBuffer[i]) trend[i] =-1;

         //
         //
         //
         //
         //
      
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
         else  CrossDn[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
         }
         
         //
         //
         //
         //
         //
         
         if (alertsOn)
         {
           if (alertsOnCurrent)
                int whichBar = 0;
           else     whichBar = 1;
         
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("uptrend");
           else  doAlert("downtrend");       
        }
   return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ZeroLagStochs ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ZeroLagStochs "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," ZeroLagStochs " +" "+message));
             if (alertsSound)   PlaySound(soundfile);
      }
}




